% Run_xUL_f2d_ttau0.m 
% for 2d time-evlofing flow (velocity) feild 
%   1. compute   
%     a) x, U=M/tau, and f (xMf) 
%     b) L=DLE from x
%   2. plot/animate M and DLE
% as t varies with fixed tau0
%
% Input files
%   1. xUL_f2d_t0tau_ip
%      a. general input - what to run (1a, 1b, 1c)
%      b. specific input - cnm.mdl/ex (flow model and experiments)
%   2. ip/"cnm.mdl"/xUL_f2d_ip_"cnm.ex"
%      model speficif input
%
% Written by Kayo Ide (University of Maryland)
% 2015 August

%%
clear all
close all

%% global
% definitions
global Nd
global ido idont
global iex_fl iex_dr
global imd_t0tau imd_ttau0
% directory & file names
global dnm_op 
global dfnm_op 
global dnm_ip dnm_f2d

%% definitions for 2D flow
xUL_f2d_df

%% input =======================================
% 1. execution & plotting/animation of xM and D
% 2. model specific input file
xUL_f2d_ip_ttau0

% end of input ====================================

%% declare
ttl='x, U=M/tau, Lambda(=DLE) as t varies with a fixed tau0';
fprintf(['\n\n        ' ttl ' for ' cnm.mdl  ' in ' int2str(Nd) 'd\n']);

%% Initilaization and Definition
cpu0=cputime;

%% setup 
% add path to current and f2d analytic model
[dnm_path]=xUL_f2d_su_path(ido,cnm);

% read input in dnm_ip/fnm_ip & setup dnm_op/fnm_op 
[dxdt_fnc,xgrd,f0,t_op,tau_op]=xUL_f2d_su(imd_ttau0,cnm,ido_bwd);
    
% check & reset output directory and file names
[ido_xU,ido_L,iplt_UL]=xUL_f2d_chck(ido_xU,ido_L,iplt_U,iplt_L,iplt_UL);

%% computation of X and M
if(ido_xU-ido==0); 
    xUL_f2d_xM_ttau0(dxdt_fnc,xgrd,f0,t_op,tau_op,ido_bwd);
end

%% computation of DLE from x
if(ido_L-ido==0);
    xUL_f2d_x2D(ido_bwd);
end

%% plot
if((iplt_U.fg-ido)*(iplt_L.fg-ido)==0); 
    xUL_f2d_plt(ido_bwd,iplt_U,iplt_L,iplt_UL,iplt_avi,cnm)
end

%% finish
fprintf('\n\n    ... end (CPU=%s sec)\n\n',num2str(cputime-cpu0))

%% remove path
[dnm_path]=xUL_f2d_su_path(idont,cnm);

return


    