function xUL_f2d_plt(ido_bwd,iplt_U,iplt_L,iplt_UL,iplt_avi,cnm)
% plot/animate M and DLE for both
%    xUL_f2d_t0tau:  fixed t0 as tau varies
%    xUL_f2d_ttau0:  as t varios with fixed tau0
%   
% Written by Kayo Ide (University of Maryland)
% 2015 August

%% global
global Nd
global ido idont
% 
global plt_prm
%
global dfnm_op dfnm_op_avi

% read data for M and DLE, set subplot frame
Jrw=0;  Jclm=3;  
if(ido_bwd-ido~=0); Jclm=Jclm-1; 
    fprintf(['\n           No backward computation (i.e., M/D=M/Dfwd)\n'])
end
scrnscl=[1 0.5 0.75 0.5];
if(iplt_U.fg-ido==0);  Jrw=Jrw+1;
    load(dfnm_op.M,'-mat');
    M=Mfwd;
    if(ido_bwd-ido==0);  M=Mfwd-Mbwd; end
    Mmx=max(Mfwd(:,end),[],1)/tau_op(end); 
end
if(iplt_L.fg-ido==0);  Jrw=Jrw+1;
    load(dfnm_op.L,'-mat');
    Dmx=max(DLEfwd(:,end),[],1);
end
if(iplt_UL.fg==ido); Jrw=Jrw+1; scrnscl(4)=0.85; end
% spatial grid
[Xgrd1,Xgrd2]=meshgrid(linspace(xgrd_op(1).mn,xgrd_op(1).mx,xgrd_op(1).n),...
    linspace(xgrd_op(2).mn,xgrd_op(2).mx,xgrd_op(2).n));    
% temporal
Ktau=length(tau_op);
% screen
scrnsz = get(0,'ScreenSize');
fscrn=scrnsz.*scrnscl;
axs=[xgrd_op(1).mn xgrd_op(1).mx xgrd_op(2).mn xgrd_op(2).mx];

%% plot 
figure('name',['U=M/tau and DLE for ' cnm.mdl ' in ' int2str(Nd) 'd'],'Position',fscrn,'Color','w');
% setup animation
set(gca,'nextplot','replacechildren');
NszMD=[xgrd_op(2).n xgrd_op(1).n];
for k=1:Ktau
    ctau=sprintf('%2.2f',tau_op(k));
    ct=sprintf('%2.2f',t_op(k));
    cttau=['(t,\tau)=(' ct ',' ctau ')'];
    jclm=0; 
    if(iplt_U.fg==ido);  jclm=jclm+1;
        for jplt=1:Jclm; 
            subplot(Jrw,Jclm,jplt+(jclm-1)*Jclm);
            if(jplt==1);     cfb='';   cT='2'; Uk= M(:,k);    caxs= plt_prm.Ucaxs;  
            elseif(jplt==2); cfb='fwd'; cT=''; Uk=-Mfwd(:,k); caxs=-plt_prm.Ucaxs(end:-1:1);
            elseif(jplt==3); cfb='bwd'; cT=''; Uk=-Mbwd(:,k); caxs= plt_prm.Ucaxs;
            end
            %-U=M/tau
            Uk=reshape(Uk,NszMD);
            if(abs(tau_op(k))~=0); 
                if(jplt==1); Uk=Uk/(2*tau_op(k));
                else; Uk=Uk/tau_op(k);
                end
            end
            pcolor(Xgrd1,Xgrd2,Uk);   shading flat;
            if(iplt_U.caxs-ido==0); caxis(caxs); end 
            title(['U at ' cttau],'fontsize',16);
            axis equal; axis(axs);  
            colormap(plt_prm.cmp)
        end
    end
    if(iplt_L.fg-ido==0);  jclm=Jrw-1;
        for jplt=1:Jclm; hold off
            subplot(Jrw,Jclm,jplt+(Jrw-1)*Jclm);
            if(jplt==1); cfb=''; cT='2'; 
                Lk=NaN*ones(NszMD);
                if(abs(tau_op(k))~=0); 
                    Lk(DLEfwd(:,k)>plt_prm.Lcof)=-1; 
                end
                pcolor(Xgrd1,Xgrd2,Lk);   shading flat;  
                if(ido_bwd-ido==0 && abs(tau_op(k))~=0);  hold on;
                    Lk=NaN*ones(NszMD);
                    Lk(DLEbwd(:,k)>plt_prm.Lcof)=1;               
                    pcolor(Xgrd1,Xgrd2,Lk);   shading flat;  hold off;
                end
                title(['DLE' cfb ' at ' cttau],'fontsize',16);   
                axis equal; axis(axs);            
                % if(iplt_L.caxs-ido==0); caxis(plt_prm.Dcaxs(end)*[-1 1]); end 
                % colorbar('Location','SouthOutside'); 
            else
                if(jplt==2);     cfb='fwd'; cT=''; Lk=-DLEfwd(:,k); caxs=-plt_prm.Lcaxs(end:-1:1);
                elseif(jplt==3); cfb='bwd'; cT=''; Lk= DLEbwd(:,k); caxs= plt_prm.Lcaxs;
                end
                Lk=reshape(Lk,NszMD); 
                pcolor(Xgrd1,Xgrd2,Lk);   shading flat;
                title(['DLE' cfb ' at ' cttau],'fontsize',16);
                axis equal; axis(axs);           
                if(iplt_L.caxs-ido==0); caxis(caxs); end % colorbar('Location','SouthOutside');
            end
            colormap(plt_prm.cmp)
        end
    end
   if(iplt_UL.fg-ido==0); jclm=jclm+1;
        for jplt=1:Jclm; hold off
            subplot(Jrw,Jclm,jplt+Jclm);
            if(jplt==1);     cfb=''; cT='2';  Uk=M(:,k);      caxs= plt_prm.Ucaxs;
                Uk(DLEfwd(:,k)>plt_prm.Lcof)=NaN;
                if(ido_bwd-ido==0); Uk(DLEbwd(:,k)>plt_prm.Lcof)=NaN; end
            elseif(jplt==2); cfb='fwd'; cT=''; Uk=-Mfwd(:,k); caxs=-plt_prm.Ucaxs(end:-1:1);
                Uk(DLEfwd(:,k)>plt_prm.Lcof)=NaN;
            elseif(jplt==3); cfb='bwd'; cT=''; Uk=-Mbwd(:,k); caxs= plt_prm.Ucaxs;
                Uk(DLEbwd(:,k)>plt_prm.Lcof)=NaN;
            end
            %-M
            Uk=reshape(Uk,NszMD);
            if(abs(tau_op(k))~=0); 
                if(jplt==1); Uk=Uk/(2*tau_op(k));
                else; Uk=Uk/tau_op(k);
                end
            end
            pcolor(Xgrd1,Xgrd2,Uk);   shading flat;
            title(['U & DLE at ' cttau],'fontsize',16);
            axis equal; axis(axs);           
            if(iplt_U.caxs-ido==0); caxis(caxs); end % colorbar('Location','SouthOutside'); 
            colormap(plt_prm.cmp)
        end
    end
    drawnow
    if(iplt_avi-ido==0); frm_avi(k)=getframe(gcf); end
end

if(iplt_avi-ido==0); movie2avi(frm_avi,dfnm_op_avi,'fps',plt_prm.avi_fps); end

if(iplt_U.fg-ido==0 && iplt_U.caxs-ido~=0); 
    fprintf('\n\n               [Mmx for caxs = %2.2f ]\n',Mmx)
end

if(iplt_L.fg-ido==0 && iplt_L.caxs-ido~=0); 
    fprintf('\n\n               [Dmx for caxs = %2.2f ]\n',Dmx)
end
return